blob: cb6fb37b93a249d8270b259797a06463ac8e2b29 [file] [log] [blame]
Leslie Giles1a1c87e2016-09-27 09:51:56 -04001#!/usr/bin/env bash
Jeremy Mordkoff6f07e6f2016-09-07 18:56:51 -04002#
3# Copyright 2016 RIFT.IO Inc
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16#
Leslie Giles1a1c87e2016-09-27 09:51:56 -040017# Author(s): Jeremy Mordkoff, Lezz Giles
Jeremy Mordkoff6f07e6f2016-09-07 18:56:51 -040018# Creation Date: 08/29/2016
19#
20#
21
22# BUILD.sh
23#
24# This is a top-level build script for RIFT.io
25#
Leslie Giles1a1c87e2016-09-27 09:51:56 -040026# Arguments and options: use -h or --help
Jeremy Mordkoff6f07e6f2016-09-07 18:56:51 -040027#
28# dependencies -- requires sudo rights
29
Leslie Giles202103e2016-09-27 13:23:40 -040030# Defensive bash programming flags
31set -o errexit # Exit on any error
32trap 'echo ERROR: Command failed: \"$BASH_COMMAND\"' ERR
33set -o nounset # Expanding an unset variable is an error. Variables must be
34 # set before they can be used.
35
Leslie Giles1a1c87e2016-09-27 09:51:56 -040036###############################################################################
37# Options and arguments
Jeremy Mordkoff6f07e6f2016-09-07 18:56:51 -040038
Leslie Giles202103e2016-09-27 13:23:40 -040039# There
40params="$(getopt -o suhb: -l install-so,install-ui,no-mkcontainer,build-ui:,help --name "$0" -- "$@")"
Leslie Giles1a1c87e2016-09-27 09:51:56 -040041if [ $? != 0 ] ; then echo "Failed parsing options." >&2 ; exit 1 ; fi
42
43eval set -- $params
44
45installSO=false
46installUI=false
Leslie Giles202103e2016-09-27 13:23:40 -040047runMkcontainer=true
Leslie Giles1a1c87e2016-09-27 09:51:56 -040048UIPathToBuild=
49
50while true; do
51 case "$1" in
52 -s|--install-so) installSO=true; shift;;
53 -u|--install-ui) installUI=true; shift;;
54 -b|--build-ui) shift; UIPathToBuild=$1; shift;;
Leslie Giles202103e2016-09-27 13:23:40 -040055 --no-mkcontainer) runMkcontainer=false; shift;;
Leslie Giles1a1c87e2016-09-27 09:51:56 -040056 -h|--help)
57 echo
58 echo "NAME:"
59 echo " $0"
60 echo
61 echo "SYNOPSIS:"
62 echo " $0 -h|--help"
63 echo " $0 [-s] [-u|-b PATH-TO-UI-REPO] [PLATFORM_REPOSITORY] [PLATFORM_VERSION]"
64 echo
65 echo "DESCRIPTION:"
66 echo " Prepare current system to run SO and UI. By default, the system"
67 echo " is set up to support building SO and UI; optionally, either or"
68 echo " both SO and UI can be installed from a Debian package repository."
69 echo
70 echo " -s|--install-so: install SO from package"
71 echo " -u|--install-ui: install UI from package"
72 echo " -b|--build-ui PATH-TO-UI-REPO: build the UI in the specified repo"
Leslie Giles202103e2016-09-27 13:23:40 -040073 echo " --no-mkcontainer: do not run mkcontainer, used for debugging script"
Leslie Giles1a1c87e2016-09-27 09:51:56 -040074 echo " PLATFORM_REPOSITORY (optional): name of the RIFT.ware repository."
75 echo " PLATFORM_VERSION (optional): version of the platform packages to be installed."
76 echo
77 exit 0;;
78 --) shift; break;;
79 *) echo "Not implemented: $1" >&2; exit 1;;
80 esac
81done
82
83if $installUI && [[ $UIPathToBuild ]]; then
84 echo "Cannot both install and build the UI!"
85 exit 1
86fi
87
88if [[ $UIPathToBuild && ! -d $UIPathToBuild ]]; then
89 echo "Not a directory: $UIPathToBuild"
90 exit 1
91fi
Jeremy Mordkoff6f07e6f2016-09-07 18:56:51 -040092
Leslie Giles202103e2016-09-27 13:23:40 -040093# Turn this on after handling options, so the output doesn't get cluttered.
94set -x # Print commands before executing them
95
96###############################################################################
97# Find the platform
Philip Josephf22a6842016-10-01 12:41:03 +053098PYTHON=python
99if [[ ! -f /usr/bin/python ]]; then
100 PYTHON=python3
101fi
102
103if $PYTHON -mplatform | grep -qi fedora; then
Leslie Giles202103e2016-09-27 13:23:40 -0400104 PLATFORM=fc20
Philip Josephf22a6842016-10-01 12:41:03 +0530105elif $PYTHON -mplatform | grep -qi ubuntu; then
Leslie Giles202103e2016-09-27 13:23:40 -0400106 PLATFORM=ub16
107else
108 echo "Unknown platform"
109 exit 1
110fi
111
112###############################################################################
113# Set up repo and version
114
115if [[ $PLATFORM == ub16 ]]; then
116 PLATFORM_REPOSITORY=${1:-OSM}
Leslie Gilescd1d2c42016-10-13 12:18:38 -0400117 PLATFORM_VERSION=${2:-4.3.1.0.50309}
Leslie Giles202103e2016-09-27 13:23:40 -0400118elif [[ $PLATFORM == fc20 ]]; then
119 PLATFORM_REPOSITORY=${1:-OSM} # change to OSM when published
Leslie Gilescd1d2c42016-10-13 12:18:38 -0400120 PLATFORM_VERSION=${2:-4.3.1.0.50310}
Leslie Giles202103e2016-09-27 13:23:40 -0400121else
122 echo "Internal error: unknown platform $PLATFORM"
123 exit 1
124fi
Jeremy Mordkoff6f07e6f2016-09-07 18:56:51 -0400125
Leslie Giles1a1c87e2016-09-27 09:51:56 -0400126###############################################################################
127# Main block
128
Jeremy Mordkoff6f07e6f2016-09-07 18:56:51 -0400129# must be run from the top of a workspace
130cd $(dirname $0)
131
Jeremy Mordkoff6f07e6f2016-09-07 18:56:51 -0400132# inside RIFT.io this is an NFS mount
133# so just to be safe
134test -h /usr/rift && sudo rm -f /usr/rift
135
Leslie Giles202103e2016-09-27 13:23:40 -0400136if [[ $PLATFORM == ub16 ]]; then
137 # enable the right repos
138 curl http://repos.riftio.com/public/xenial-riftware-public-key | sudo apt-key add -
139 sudo curl -o /etc/apt/sources.list.d/${PLATFORM_REPOSITORY}.list http://buildtracker.riftio.com/repo_file/ub16/${PLATFORM_REPOSITORY}/
140 sudo apt-get update
141
142 # and install the tools
143 sudo apt remove -y rw.toolchain-rwbase tcpdump
144 sudo apt-get install -y rw.tools-container-tools rw.tools-scripts python
145elif [[ $PLATFORM == fc20 ]]; then
146 # get the container tools from the correct repository
147 sudo rm -f /etc/yum.repos.d/private.repo
148 sudo curl -o /etc/yum.repos.d/${PLATFORM_REPOSITORY}.repo \
149 http://buildtracker.riftio.com/repo_file/fc20/${PLATFORM_REPOSITORY}/
150 sudo yum install --assumeyes rw.tools-container-tools rw.tools-scripts
151else
152 echo "Internal error: unknown platform $PLATFORM"
153 exit 1
154fi
Jeremy Mordkoff6f07e6f2016-09-07 18:56:51 -0400155
156# enable the OSM repository hosted by RIFT.io
157# this contains the RIFT platform code and tools
158# and install of the packages required to build and run
159# this module
Leslie Giles202103e2016-09-27 13:23:40 -0400160if $runMkcontainer; then
161 sudo /usr/rift/container_tools/mkcontainer --modes build --modes ext --repo ${PLATFORM_REPOSITORY}
Leslie Giles1a1c87e2016-09-27 09:51:56 -0400162fi
163
Leslie Giles202103e2016-09-27 13:23:40 -0400164
165if [[ $PLATFORM == ub16 ]]; then
166 # install the RIFT platform code:
Jeremy Mordkoffba693292016-11-18 11:30:28 -0500167 sudo apt-get install -y --allow-downgrades rw.toolchain-rwbase=${PLATFORM_VERSION} \
Leslie Giles202103e2016-09-27 13:23:40 -0400168 rw.toolchain-rwtoolchain=${PLATFORM_VERSION} \
169 rw.core.mgmt-mgmt=${PLATFORM_VERSION} \
170 rw.core.util-util=${PLATFORM_VERSION} \
171 rw.core.rwvx-rwvx=${PLATFORM_VERSION} \
172 rw.core.rwvx-rwdts=${PLATFORM_VERSION} \
173 rw.automation.core-RWAUTO=${PLATFORM_VERSION} \
174 rw.core.rwvx-rwha-1.0=${PLATFORM_VERSION}
175
176 sudo chmod 777 /usr/rift /usr/rift/usr/share
177
178 if $installSO; then
179 sudo apt-get install -y \
180 rw.core.mc-\*=${PLATFORM_VERSION}
181 fi
182
183 if $installUI; then
184 sudo apt-get install -y \
185 rw.ui-about=${PLATFORM_VERSION} \
186 rw.ui-logging=${PLATFORM_VERSION} \
187 rw.ui-skyquake=${PLATFORM_VERSION} \
188 rw.ui-accounts=${PLATFORM_VERSION} \
189 rw.ui-composer=${PLATFORM_VERSION} \
190 rw.ui-launchpad=${PLATFORM_VERSION} \
191 rw.ui-debug=${PLATFORM_VERSION} \
192 rw.ui-config=${PLATFORM_VERSION} \
193 rw.ui-dummy_component=${PLATFORM_VERSION}
194 fi
195elif [[ $PLATFORM == fc20 ]]; then
196
197 temp=$(mktemp -d /tmp/rw.XXX)
198 pushd $temp
199
200 # yum does not accept the --nodeps and --replacefiles options so we
201 # download first and then install
202 yumdownloader rw.toolchain-rwbase-${PLATFORM_VERSION} \
203 rw.toolchain-rwtoolchain-${PLATFORM_VERSION} \
204 rw.core.mgmt-mgmt-${PLATFORM_VERSION} \
205 rw.core.util-util-${PLATFORM_VERSION} \
206 rw.core.rwvx-rwvx-${PLATFORM_VERSION} \
207 rw.core.rwvx-rwha-1.0-${PLATFORM_VERSION} \
208 rw.core.rwvx-rwdts-${PLATFORM_VERSION} \
209 rw.automation.core-RWAUTO-${PLATFORM_VERSION}
210
211 # Install one at a time so that pre-installed packages will not cause a failure
212 for pkg in *rpm; do
213 # Check to see if the package is already installed; do not try to install
214 # it again if it does, since this causes rpm -i to return failure.
215 if rpm -q $(rpm -q -p $pkg) >/dev/null; then
216 echo "WARNING: package already installed: $pkg"
217 else
218 sudo rpm -i --replacefiles --nodeps $pkg
219 fi
220 done
221
222 popd
223 rm -rf $temp
224
225 # this file gets in the way of the one generated by the build
226 sudo rm -f /usr/rift/usr/lib/libmano_yang_gen.so
227
228
229 sudo chmod 777 /usr/rift /usr/rift/usr/share
230
231 if $installSO; then
232 sudo apt-get install -y \
233 rw.core.mc-\*-${PLATFORM_VERSION}
234 fi
235
236 if $installUI; then
237 sudo apt-get install -y \
238 rw.ui-about-${PLATFORM_VERSION} \
239 rw.ui-logging-${PLATFORM_VERSION} \
240 rw.ui-skyquake-${PLATFORM_VERSION} \
241 rw.ui-accounts-${PLATFORM_VERSION} \
242 rw.ui-composer-${PLATFORM_VERSION} \
243 rw.ui-launchpad-${PLATFORM_VERSION} \
244 rw.ui-debug-${PLATFORM_VERSION} \
245 rw.ui-config-${PLATFORM_VERSION} \
246 rw.ui-dummy_component-${PLATFORM_VERSION}
247 fi
248
249else
250 echo "Internal error: unknown platform $PLATFORM"
251 exit 1
Leslie Giles1a1c87e2016-09-27 09:51:56 -0400252fi
253
Jeremy Mordkoff6f07e6f2016-09-07 18:56:51 -0400254# install some base files used to create VNFs
255test -d /usr/rift/images || mkdir /usr/rift/images
256for file in Fedora-x86_64-20-20131211.1-sda-ping.qcow2 Fedora-x86_64-20-20131211.1-sda-pong.qcow2 Fedora-x86_64-20-20131211.1-sda.qcow2; do
257 test -f /usr/rift/images/$file || curl -o /usr/rift/images/$file http://repo.riftio.com/releases/open.riftio.com/4.3.1/$file
258done
259
Leslie Giles1a1c87e2016-09-27 09:51:56 -0400260# If you are re-building SO, you just need to run
Jeremy Mordkoff6f07e6f2016-09-07 18:56:51 -0400261# these two steps
Leslie Giles1a1c87e2016-09-27 09:51:56 -0400262if ! $installSO; then
263 make -j16
264 sudo make install
265fi
Jeremy Mordkoff6f07e6f2016-09-07 18:56:51 -0400266
Leslie Giles1a1c87e2016-09-27 09:51:56 -0400267if [[ $UIPathToBuild ]]; then
268 make -C $UIPathToBuild -j16
269 sudo make -C $UIPathToBuild install
270fi
271
272echo "To run SO with UI please run:"
273echo 'sudo -H /usr/rift/rift-shell -r -i /usr/rift -a /usr/rift/.artifacts -- ./demos/launchpad.py --use-xml-mode'
274echo
275echo "To run SO without UI please run:"
Rajesh1b20e0c2016-09-26 18:01:15 -0400276echo 'sudo -H /usr/rift/rift-shell -r -i /usr/rift -a /usr/rift/.artifacts -- ./demos/launchpad.py --use-xml-mode --no-ui'